Index: /trunk/gli/src/org/greenstone/gatherer/gems/ElementWrapper.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/gems/ElementWrapper.java	(revision 8970)
+++ /trunk/gli/src/org/greenstone/gatherer/gems/ElementWrapper.java	(revision 8971)
@@ -63,7 +63,6 @@
     private String namespace = "";
     private ArrayList subelements = null; //The list of subelements
-    // private XMLTools xmlTools = new XMLTools(); //uh, a class of XML tools, i guess
-
     private Troolean is_extracted = new Troolean();
+
     /** Constructor for elements with no namespace necessary.
      * @param element The DOM <strong>Element</strong> this is to be based on.
@@ -95,5 +94,5 @@
        @param name the name of the subelement to check for, as a <strong>String</strong> 
        @author Matthew Whyte
-       @date last modified: 19/01/04
+       Date last modified: 19/01/04
     */
     public boolean containsSubelement(String name)
@@ -113,4 +112,15 @@
     }
 
+    /*
+      Check to see if the element contains any subelements
+      @return tree if element contains subelements
+      @author Matthew Whyte
+      Date last modified: 2/02/05
+     */
+    public boolean containsSubelements()
+    {
+	return(subelements.size() != 0);
+    }
+
     /**
        Method to add a subelement to the list of subelements.
@@ -122,4 +132,15 @@
     {
 	subelements.add(element);
+    }
+
+    /**
+       Method to remove a subelement from the list of subelements.
+       @param element the subelement to remove from the list, as a <strong>Element</strong>
+       @author Matthew Whyte
+       Date last modified: 27/01/05
+     */
+    public void removeSubelementFromList(Element element)
+    {
+	subelements.remove(element);
     }
 
Index: /trunk/gli/src/org/greenstone/gatherer/gems/GEMS.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/gems/GEMS.java	(revision 8970)
+++ /trunk/gli/src/org/greenstone/gatherer/gems/GEMS.java	(revision 8971)
@@ -36,5 +36,4 @@
 package org.greenstone.gatherer.gems;
 
-
 import java.awt.*;
 import java.awt.event.*;
@@ -87,19 +86,13 @@
     static final private Dimension ADD_ELEMENT_SIZE = new Dimension(400,125);
     static final private Dimension RENAME_ELEMENT_SIZE = new Dimension(400, 95);
-    static final private Dimension ADD_FILE_SIZE = new Dimension(400,125);
     static final private Dimension ADD_SET_SIZE = new Dimension(400,150);
     static final private Dimension RENAME_SET_SIZE = new Dimension(400,120);
     static final private Dimension OPEN_SETS_SIZE = new Dimension(400,135);
     static final private Dimension ADD_OR_EDIT_ATTRIBUTE_SIZE = new Dimension(600,325);
-    static final private Dimension ADD_OR_EDIT_VALUE_SIZE = new Dimension(600,440);
-    
     static final private Dimension COMPONENT_SIZE = new Dimension(300,30);
     static final private Dimension SIZE = new Dimension(800,480);
     static final private String BLANK = "blank";
     static final private String ELEMENT = "element";
-    static final private String PROFILE = "profile";
     static final private String SET = "set";
-    static final private String SUBELEMENT = "subelement";
-    static final private String VALUES = "values";
 
     static final public String METADATA_SET_TEMPLATE = "xml/template.mds";
@@ -109,31 +102,21 @@
     static final public int T_COLLECTION = 0;
     static final public int T_ELEMENT    = 1;
-    static final public int T_PROFILER   = 2;
-    static final public int T_ROOT       = 3; 
     static final public int T_SET        = 4;
-    static final public int T_SUBELEMENT = 5;
-
-   // static final public String MAX_LOADED_SETS = 64;
+
+    //static final public String MAX_LOADED_SETS = 64;
     static public Configuration config = null;
     private MetadataSetManager msm = new MetadataSetManager(this);
 
     public AddElementActionListener add_element_action_listener = null;
-    private AddFileActionListener add_file_action_listener = null;
     public  AddSetActionListener add_set_action_listener = null;
     /** The class used to handle add or edit attribute actions has to be globally available so that we can dispose of its dialog properly. */
     public AddOrEditAttributeActionListener add_or_edit_attribute_action_listener = null;
-    /** The class used to handle add or edit value actions has to be globally available so that we can dispose of its dialog properly. */
-    //public AddOrEditValueActionListener add_or_edit_value_action_listener = null;
     private boolean ignore = false;
     /** A card layout is used to switch between the two differing detail views. */ 
     private CardLayout card_layout = null;
-    /** A card layout is used to switch between a value tree or an empty placeholder (if no value tree available). */
-    private CardLayout element_values_layout = null;
 
     /** Um, the size of the screen I'd guess. */
     private Dimension screen_size = null;
     private ElementWrapper current_element = null;
-    private ElementWrapper current_subelement = null;
-    private GValueNode current_value_node = null;
     /** A reference to ourselves so our inner classes can dispose of us. */
     private GEMS self = null;
@@ -142,24 +125,15 @@
     private int current_attribute_type = -1;
 
-    private JLabel element_name = null;
-    private JLabel profile_name = null;
+    //private JLabel element_name = null;
     private JLabel set_name = null;
     private JScrollPane element_attributes_scroll = null;
-    private JScrollPane profile_attributes_scroll = null;
     private JScrollPane set_attributes_scroll = null;
-    private JScrollPane subelement_attributes_scroll = null;
     private JPanel details_pane = null;
-    private JPanel element_values_pane = null;
-    private KeepTreeRootExpandedListener keep_root_expanded_listener = null;
     private GEMSModel model = null;
     private GEMSNode current_node = null;
     private MetadataSet current_set = null;
-    private Object target = null;
     public RemoveSetActionListener remove_set_action_listener;
-    private SmarterTable subelement_attributes = null;
     private SmarterTable element_attributes = null;
-    private SmarterTable profile_attributes = null;
     private SmarterTable set_attributes = null;
-    private SmarterTree element_values = null;
     public org.w3c.dom.Element rootelement;
    
@@ -171,5 +145,4 @@
     /** A tree that represents the current metadata sets associated with this collection. */
     private SmarterTree mds_tree = null;
-    private String current_collection_file = null;
     private String dialog_options[] = null;
     private boolean atLeastOneSetChanged = false;
@@ -195,6 +168,4 @@
            
 	    config = new Configuration(go.gsdl_path, null, null);
-        
-           
 	}
 	catch (Exception exception) {
@@ -226,16 +197,4 @@
 	dialog_options[1] = Dictionary.get("General.Cancel");
 
-	// Creation
-	setDefaultCloseOperation(DISPOSE_ON_CLOSE);
-	setSize(SIZE);
-	setJMenuBar(new GEMSMenuBar());
-	Dictionary.setText(this, "GEMS.Title");
-
-	JPanel content_pane = (JPanel) getContentPane();
-	content_pane.setBackground(config.getColor("coloring.collection_heading_background", false));
-		  
-	JPanel upper_pane = new JPanel();
-	upper_pane.setOpaque(false);
-		  
 	// Load all the core metadata sets (in the GLI "metadata" directory)
 	model = new GEMSModel();
@@ -254,7 +213,36 @@
 	}
 
+	// Creation
+	setDefaultCloseOperation(DISPOSE_ON_CLOSE);
+	setSize(SIZE);
+	setJMenuBar(new GEMSMenuBar());
+	Dictionary.setText(this, "GEMS.Title");
+
+	JPanel content_pane = (JPanel) getContentPane();
+	content_pane.setBackground(config.getColor("coloring.collection_heading_background", false));	  
+	JPanel upper_pane = new JPanel();
+	upper_pane.setOpaque(false);
+	JPanel set_details_pane = new JPanel();
+	set_details_pane.setOpaque(false);
+	JPanel set_name_pane = new JPanel();
+	set_name_pane.setOpaque(false);
+	JLabel set_name_label = new JLabel();
+	set_name_label.setOpaque(false);
+	JPanel element_details_pane = new JPanel();
+	element_details_pane.setOpaque(false);	  
+	JPanel element_inner_pane = new JPanel();
+	element_inner_pane.setOpaque(false);
+	JPanel blank_pane = new JPanel(); // Some blank panel
+	blank_pane.setOpaque(false);
+
+	details_pane = new JPanel();
+	details_pane.setOpaque(false);
+	card_layout = new CardLayout();
+	set_name = new JLabel();
+	
 	JPanel mds_tree_pane = new JPanel();
 	mds_tree_pane.setOpaque(false);
 	mds_tree_pane.setPreferredSize(new Dimension(300,500));
+
 	mds_tree = new SmarterTree(model);
 	mds_tree.setCellRenderer(new GEMSTreeCellRenderer());
@@ -264,21 +252,8 @@
 	mds_tree.setSelectionColor(config.getColor("coloring.collection_selection_background", false));
 	mds_tree.setSelectedTextColor(config.getColor("coloring.collection_selection_foreground", false));
-        
         //add popupevent handler for tree items
-      
         mds_tree.addMouseListener(popupListener);
 	mds_tree.addKeyListener(new KeyPressedHandler());
-	details_pane = new JPanel();
-	details_pane.setOpaque(false);
-	card_layout = new CardLayout();
-		  
-	JPanel set_details_pane = new JPanel();
-	set_details_pane.setOpaque(false);
-		  
-	JPanel set_name_pane = new JPanel();
-	set_name_pane.setOpaque(false);
-	JLabel set_name_label = new JLabel();
-	set_name_label.setOpaque(false);
-	set_name = new JLabel();
+	mds_tree.addTreeSelectionListener(new MDSTreeSelectionListener());
 		  
 	JPanel set_attributes_pane = new JPanel();
@@ -300,14 +275,5 @@
 	set_attributes.addMouseListener(new AddOrEditAttributeActionListener());
 	set_attributes.addKeyListener(new RemoveAttributeActionListener()); //Listen for DELETE key
-	JPanel element_details_pane = new JPanel();
-	element_details_pane.setOpaque(false);
-
-	JPanel element_name_pane = new JPanel();
-	element_name_pane.setOpaque(false);
-	JLabel element_name_label = new JLabel();
-	element_name_label.setOpaque(false);
-		  
-	JPanel element_inner_pane = new JPanel();
-	element_inner_pane.setOpaque(false);
+	set_attributes.getSelectionModel().addListSelectionListener(new AttributesListSelectionListener(set_attributes));
 		  
 	JPanel element_attributes_pane = new JPanel();
@@ -328,121 +294,10 @@
 	element_attributes.addMouseListener(new AddOrEditAttributeActionListener());
 	element_attributes.addKeyListener(new RemoveAttributeActionListener()); //For the DELETE key
-        
-	element_values_layout = new CardLayout();
-	element_values_pane = new JPanel();
-	element_values_pane.setOpaque(false);
-	element_values = new SmarterTree();
-	element_values.setBackground(config.getColor("coloring.collection_tree_background", false));
-	element_values.setForeground(config.getColor("coloring.collection_tree_foreground", false));
-	element_values.setRootVisible(false);
-	element_values.setSelectionColor(config.getColor("coloring.collection_selection_background", false));
-	element_values.setSelectedTextColor(config.getColor("coloring.collection_selection_foreground", false));
-		
-	JPanel subelement_details_pane = new JPanel();
-	subelement_details_pane.setOpaque(false);
-	JPanel subelement_name_pane = new JPanel();
-	subelement_name_pane.setOpaque(false);
-	JLabel subelement_name_label = new JLabel();
-	subelement_name_label.setOpaque(false);
-	JPanel subelement_inner_pane = new JPanel();
-	subelement_inner_pane.setOpaque(false);
-
-	JPanel subelement_attributes_pane = new JPanel();
-	subelement_attributes_pane.setOpaque(false);
-	subelement_attributes_scroll = new JScrollPane();
-	subelement_attributes_scroll.getViewport().setBackground(config.getColor("coloring.collection_tree_background", false));
-	subelement_attributes_scroll.setOpaque(true);
-	subelement_attributes = new SmarterTable();
-	subelement_attributes.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
-	subelement_attributes.setBackground(config.getColor("coloring.collection_tree_background", false));
-	subelement_attributes.setForeground(config.getColor("coloring.collection_tree_foreground", false));
-	subelement_attributes.setHeadingBackground(config.getColor("coloring.collection_heading_background", false));
-	subelement_attributes.setHeadingForeground(config.getColor("coloring.collection_heading_foreground", false));
-	subelement_attributes.setSelectionColor(config.getColor("coloring.collection_selection_background", false));
-	subelement_attributes.setSelectedTextColor(config.getColor("coloring.collection_selection_foreground", false));
-	subelement_attributes.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
-        subelement_attributes.addMouseListener(popupListener);
-	subelement_attributes.addMouseListener(new AddOrEditAttributeActionListener());
-	subelement_attributes.addKeyListener(new RemoveAttributeActionListener()); //For the DELETE key
-	
-	JPanel element_novalues_pane = new JPanel();
-
-	keep_root_expanded_listener = new KeepTreeRootExpandedListener();
-
-	JPanel profile_details_pane = new JPanel();
-	profile_details_pane.setOpaque(false);
-	JPanel profile_name_pane = new JPanel();
-	profile_name_pane.setOpaque(false);
-	JLabel profile_name_label = new JLabel();
-	profile_name_label.setOpaque(false);
-	profile_name = new JLabel();
-	profile_name.setBorder(BorderFactory.createLoweredBevelBorder());
-	profile_name.setOpaque(false);
-
-	JPanel profile_attributes_pane = new JPanel();
-	profile_attributes_pane.setOpaque(false);
-	profile_attributes_scroll = new JScrollPane();
-	profile_attributes_scroll.getViewport().setBackground(config.getColor("coloring.collection_tree_background", false));
-	profile_attributes_scroll.setOpaque(true);
-	profile_attributes = new SmarterTable();
-	profile_attributes.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
-	profile_attributes.setBackground(config.getColor("coloring.collection_tree_background", false));
-	profile_attributes.setForeground(config.getColor("coloring.collection_tree_foreground", false));
-	profile_attributes.setHeadingBackground(config.getColor("coloring.collection_heading_background", false));
-	profile_attributes.setHeadingForeground(config.getColor("coloring.collection_heading_foreground", false));
-	profile_attributes.setSelectionColor(config.getColor("coloring.collection_selection_background", false));
-	profile_attributes.setSelectedTextColor(config.getColor("coloring.collection_selection_foreground", false));
-	profile_attributes.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
-
-	JPanel button_pane = new JPanel();
-	button_pane.setOpaque(false);
-
-	JPanel button_label_pane = new JPanel();
-	button_label_pane.setOpaque(false);
-
-	JLabel attribute_label = new JLabel();
-	attribute_label.setOpaque(false);
-	Dictionary.setText(attribute_label, "GEMS.Attribute");
-
-	JLabel element_label = new JLabel();
-	element_label.setOpaque(false);
-	Dictionary.setText(element_label, "GEMS.Element");
-
-	JLabel file_label = new JLabel();
-	file_label.setOpaque(false);
-	Dictionary.setText(file_label, "GEMS.File");
-
-	JLabel set_label = new JLabel();
-	set_label.setOpaque(false);
-	Dictionary.setText(set_label, "GEMS.Set");
-
-	JLabel value_label = new JLabel();
-	value_label.setOpaque(false);
-	Dictionary.setText(value_label, "GEMS.Value");
-
-	JPanel inner_button_pane = new JPanel();
-	inner_button_pane.setOpaque(false);
+	element_attributes.getSelectionModel().addListSelectionListener(new AttributesListSelectionListener(element_attributes));
 
 	add_element_action_listener = new AddElementActionListener();
-	add_file_action_listener = new AddFileActionListener();
 	add_set_action_listener = new AddSetActionListener();
 	add_or_edit_attribute_action_listener = new AddOrEditAttributeActionListener();
 	remove_set_action_listener = new RemoveSetActionListener();
-
-	// Some blank panel
-	JPanel blank_pane = new JPanel();
-	blank_pane.setOpaque(false);
-	JPanel edit_file_pane = new JPanel();
-	edit_file_pane.setOpaque(false);
-	JPanel edit_element_pane = new JPanel();
-	edit_element_pane.setOpaque(false);
-	JPanel edit_set_pane = new JPanel();
-	edit_set_pane.setOpaque(false);
-
-	element_attributes.getSelectionModel().addListSelectionListener(new AttributesListSelectionListener(element_attributes));
-	subelement_attributes.getSelectionModel().addListSelectionListener(new AttributesListSelectionListener(subelement_attributes));
-	profile_attributes.getSelectionModel().addListSelectionListener(new AttributesListSelectionListener(profile_attributes));
-	set_attributes.getSelectionModel().addListSelectionListener(new AttributesListSelectionListener(set_attributes));
-	mds_tree.addTreeSelectionListener(new MDSTreeSelectionListener());
 
 	// Layout
@@ -450,4 +305,5 @@
 	mds_tree_pane.add(new JScrollPane(mds_tree), BorderLayout.CENTER);
 		  
+	//Set panes
 	set_name_pane.setLayout(new BorderLayout());
 	set_name_pane.add(set_name_label, BorderLayout.WEST);
@@ -455,5 +311,4 @@
 				
 	set_attributes_scroll.setViewportView(set_attributes);
-
 	set_attributes_pane.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createTitledBorder(Dictionary.get("GEMS.Attributes")), BorderFactory.createEmptyBorder(2,2,2,2)));
 	set_attributes_pane.setLayout(new BorderLayout());
@@ -464,59 +319,19 @@
 	set_details_pane.add(set_name_pane, BorderLayout.NORTH);
 	set_details_pane.add(set_attributes_pane, BorderLayout.CENTER);
-
-	element_name_pane.setLayout(new BorderLayout());
-	//element_name_pane.add(element_name_label, BorderLayout.WEST);
-	//element_name_pane.add(element_name, BorderLayout.CENTER);
-				
+		
+	//Element panes
 	element_attributes_scroll.setViewportView(element_attributes);
-
 	element_attributes_pane.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createTitledBorder(Dictionary.get("GEMS.Attributes")), BorderFactory.createEmptyBorder(2,2,2,2)));
 	element_attributes_pane.setLayout(new BorderLayout());
 	element_attributes_pane.add(element_attributes_scroll, BorderLayout.CENTER);
 		  
-	element_values_pane.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createTitledBorder(Dictionary.get("GEMS.Values")), BorderFactory.createEmptyBorder(2,2,2,2)));
-	element_values_pane.setLayout(new BorderLayout());
-	element_values_pane.add(new JScrollPane(element_values), BorderLayout.CENTER);
-	element_values_pane.setLayout(element_values_layout);
-	//element_values_pane.add(element_novalues_pane, BLANK);
-	//element_values_pane.add(new JScrollPane(element_values), VALUES);
-
 	element_inner_pane.setLayout(new BorderLayout());
 	element_inner_pane.add(element_attributes_pane);
-	//element_inner_pane.add(element_values_pane);
 		  
 	element_details_pane.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createTitledBorder(Dictionary.get("GEMS.Element_Details")), BorderFactory.createEmptyBorder(2,2,2,2)));
 	element_details_pane.setLayout(new BorderLayout());
-	//element_details_pane.add(element_name_pane, BorderLayout.NORTH);
 	element_details_pane.add(element_inner_pane, BorderLayout.CENTER);
-	
-	subelement_name_pane.setLayout(new BorderLayout());
-	subelement_attributes_scroll.setViewportView(subelement_attributes);
-	subelement_attributes_pane.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createTitledBorder(Dictionary.get("GEMS.Attributes")), BorderFactory.createEmptyBorder(2,2,2,2)));
-	subelement_attributes_pane.setLayout(new BorderLayout());
-	subelement_attributes_pane.add(subelement_attributes_scroll, BorderLayout.CENTER);
-	
-
-	subelement_inner_pane.setLayout(new BorderLayout());
-	subelement_inner_pane.add(subelement_attributes_pane);
-	subelement_details_pane.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createTitledBorder(Dictionary.get("GEMS.Subelement_Details")), BorderFactory.createEmptyBorder(2,2,2,2)));
-	subelement_details_pane.setLayout(new BorderLayout());
-	subelement_details_pane.add(subelement_inner_pane, BorderLayout.CENTER);
-	
-	profile_name_pane.setLayout(new BorderLayout());
-	profile_name_pane.add(profile_name_label, BorderLayout.WEST);
-	profile_name_pane.add(profile_name, BorderLayout.CENTER);
-
-	profile_attributes_scroll.setViewportView(profile_attributes);
-
-	profile_attributes_pane.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createTitledBorder(Dictionary.get("GEMS.Profiles")), BorderFactory.createEmptyBorder(2,2,2,2)));
-	profile_attributes_pane.setLayout(new BorderLayout());
-	profile_attributes_pane.add(profile_attributes_scroll, BorderLayout.CENTER);
-
-	profile_details_pane.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createTitledBorder(Dictionary.get("GEMS.Profile_Details")), BorderFactory.createEmptyBorder(2,2,2,2)));
-	profile_details_pane.setLayout(new BorderLayout());
-	//profile_details_pane.add(profile_name_pane, BorderLayout.NORTH);
-	profile_details_pane.add(profile_attributes_pane, BorderLayout.CENTER);
-
+
+	//General panes
 	details_pane.setBorder(BorderFactory.createEmptyBorder(0,5,0,0));
 	details_pane.setLayout(card_layout);
@@ -524,25 +339,12 @@
 	details_pane.add(set_details_pane, SET);
 	details_pane.add(element_details_pane, ELEMENT);
-	details_pane.add(subelement_details_pane, SUBELEMENT);
-	details_pane.add(profile_details_pane, PROFILE);
 
 	upper_pane.setLayout(new BorderLayout());
 	upper_pane.add(mds_tree_pane, BorderLayout.WEST);
 	upper_pane.add(details_pane, BorderLayout.CENTER);
-		  
-	button_label_pane.setLayout(new GridLayout(4,1,0,2));
-	button_label_pane.setBorder(BorderFactory.createEmptyBorder(0,0,0,2));
-
-	inner_button_pane.setLayout(new GridLayout(4,3,0,2));		
-		  
-	button_pane.setBorder(BorderFactory.createEmptyBorder(5,0,0,0));
-	button_pane.setLayout(new BorderLayout());
-	//button_pane.add(button_label_pane, BorderLayout.WEST);
-	//button_pane.add(inner_button_pane, BorderLayout.CENTER);
 
 	content_pane.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
 	content_pane.setLayout(new BorderLayout());
 	content_pane.add(upper_pane, BorderLayout.CENTER);
-	content_pane.add(button_pane, BorderLayout.SOUTH);
 
 	// initialise the selection
@@ -628,5 +430,4 @@
 	    file_save.addActionListener(this);
 	    file_save.setMnemonic(KeyEvent.VK_S);
-	   // Dictionary.registerText(file_save, "GEMS.Menu.File_Save");
             Dictionary.registerText(file_save, "Menu.File_Save");
             
@@ -634,5 +435,4 @@
 	    file_delete.addActionListener(new KeyPressedHandler()); //KeyPressedHandler handles deleting stuff.
 	    file_delete.setMnemonic(KeyEvent.VK_S);
-	   // Dictionary.registerText(file_delete, "GEMS.Menu.File_Delete");
             Dictionary.registerText(file_delete, "Menu.File_Delete");
             
@@ -640,5 +440,4 @@
 	    file_preferences.addActionListener(this);
 	    file_preferences.setMnemonic(KeyEvent.VK_S);
-	    //Dictionary.registerText(file_preferences, "GEMS.Menu.File_Preferences");
             Dictionary.registerText(file_preferences, "Menu.File_Options");
 
@@ -678,5 +477,5 @@
 	    edit.add(edit_paste);
 
-	    // Help menu
+	    // Help menu. Is not used! --Matthew
 	    help = new JMenu();
 	    help.setIcon(Utility.HELP_ICON);
@@ -805,9 +604,5 @@
 	{
 	    String file_name = file.getName().toLowerCase();
-	    if (file_name.endsWith(".mds") || file_name.indexOf(".") == -1) {
-		return true;
-	    }
-
-	    return false;
+	    return(file_name.endsWith(".mds") || file_name.indexOf(".") == -1);
 	}
 
@@ -860,6 +655,4 @@
           exit();
        }
-       
-  
    }
    //called from MetadataSetManager...I don't think it should be here anymore, but for now it's ok
@@ -889,10 +682,6 @@
 	element_attributes = null;
 	set_attributes = null;
-	subelement_attributes = null;
-	element_name = null;
 	set_name = null;
-	element_values = null;
 	mds_tree = null;
-	target = null;
         
         popupListener = null;
@@ -916,21 +705,21 @@
        Class to handle adding or modifying element attributes.
      */
-   private class AddOrEditAttributeActionListener
+    private class AddOrEditAttributeActionListener
 	extends ModalDialog
 	implements ActionListener, MouseListener {
-       private boolean add_type = true;
-       private ComboArea value = null;
-       private JButton cancel_button = null;
-       private JButton ok_button = null;
-       private JComboBox language_box = null;
-       private GComboBox name = null;
-       private HashMap name_to_values = null;
-       private JLabel target = null;
-       private JLabel target_label = null;
-       private Vector attributeLists = null;      
-       
+	private boolean add_type = true;
+	private ComboArea value = null;
+	private JButton cancel_button = null;
+	private JButton ok_button = null;
+	private JComboBox language_box = null;
+	private GComboBox name = null;
+	private HashMap name_to_values = null;
+	private JLabel target = null;
+	private JLabel target_label = null;
+	private Vector attributeLists = null;      
+	
         //org.w3c.dom.Document lang = Utility.parse("/home/arosmain/gsdl/gli/classes/xml/languages.xml", false);
-          org.w3c.dom.Document lang = Utility.parse(Configuration.gsdl_path + "/gli/classes/xml/languages.xml", false);
-          
+	org.w3c.dom.Document lang = Utility.parse(Configuration.gsdl_path + "/gli/classes/xml/languages.xml", false);
+	
 	/** Constructor. */
 	public AddOrEditAttributeActionListener() {
@@ -938,10 +727,9 @@
 	    setModal(true);
             attributeLists = new Vector();
-            //
             attributeLists.add("identifier");
             attributeLists.add("comment");
             attributeLists.add("definition");
             attributeLists.add("name");
-            
+
             attributeLists.add("creator");
             attributeLists.add("date");
@@ -1009,4 +797,5 @@
 	    ok_button = new GLIButton();
 	    ok_button.setMnemonic(KeyEvent.VK_O);
+	    getRootPane().setDefaultButton(ok_button);
 	    Dictionary.setBoth(ok_button, "General.OK", "General.OK_Tooltip");
 	    cancel_button = new GLIButton();
@@ -1073,5 +862,5 @@
        public void mouseClicked(MouseEvent e)
 	{
-	    if(e.getSource() == element_attributes || e.getSource() == set_attributes || e.getSource() == subelement_attributes)
+	    if(e.getSource() == element_attributes || e.getSource() == set_attributes)
 		{
 		    if(e.getClickCount() == 2) //Double click
@@ -1083,20 +872,9 @@
 		}
 	}
-	//required by MouseListener
-	public void mouseEntered(MouseEvent e)
-	{
-	}
-	//required by MouseListener
-	public void mouseExited(MouseEvent e)
-	{
-	}
-	//required by MouseListener
-	public void mousePressed(MouseEvent e)
-	{
-	}
-	//required by MouseListener
-	public void mouseReleased(MouseEvent e)
-	{
-	}
+	//These methods are required by interface MouseListener
+	public void mouseEntered(MouseEvent e){}
+	public void mouseExited(MouseEvent e){}
+	public void mousePressed(MouseEvent e){}
+	public void mouseReleased(MouseEvent e){}
 
 	/** Any implementation of ActionListener must include this method so that we can be informed when an action as occured on our registered component, allowing us to add a new attribute to the selected set or element.
@@ -1105,8 +883,5 @@
 	public void actionPerformed(ActionEvent event) {
 	    Object source = event.getSource();
-            AttributeTableModel tablemodel = null;
 	    AttributeTableModel model = null;
-            String prevLang = new String("");
-            String prevValue = new String("");
            
 	    if(current_element != null)
@@ -1120,9 +895,4 @@
 		    target.setText(current_set.toString());
 		    Dictionary.setText(target_label, "GEMS.Target");
-		}
-	    else if(current_subelement != null)
-		{
-		    target.setText(current_subelement.getName());
-		    Dictionary.setText(target_label, "GEMS.Subelement");
 		}
 	    
@@ -1135,14 +905,9 @@
 		boolean success = true;
 
-		// Add or edit a collect/set/element attribute
+		// Add or edit a set/element attribute
 		switch(current_attribute_type) {
-		case GEMSNode.COLLECTION:
-		    model = (AttributeTableModel) profile_attributes.getModel();
-		    success = addOrEditCollectionAttribute(model);
-		    break;
 		case GEMSNode.SET:
 		    model = (AttributeTableModel) set_attributes.getModel();
-		    success = addOrEditSetAttribute(model);	
-                   
+		    success = addOrEditSetAttribute(model);
 		    break;
 		case GEMSNode.ELEMENT:
@@ -1150,15 +915,8 @@
 		    success = addOrEditElementAttribute(model);
 		    break;
-		    
-		case GEMSNode.SUBELEMENT:
-		    model = (AttributeTableModel) subelement_attributes.getModel();
-		    success = addOrEditSubelementAttribute(model);
-		    break;
-		    
 		}
                  
 		if (success) {
 		    // Hide dialog
-                
 		    atLeastOneSetChanged = true;
 		    setVisible(false);
@@ -1180,7 +938,4 @@
 		if(object != null) {
 		    java.util.List values = (java.util.List) name_to_values.get(object.toString());
-		    if(values == null && current_attribute_type==GEMSNode.COLLECTION) { 
-			values = msm.getElements();
-		    }
                     
                     if(value != null && values != null){
@@ -1192,5 +947,5 @@
 		}
 	    }
-	    else if (source == popupListener.menuAddAttributeAttribute || source == popupListener.menuAddAttributeSet || source == popupListener.menuAddAttributeElement || source == popupListener.menuAddAttributeSubelement){
+	    else if (source == popupListener.menuAddAttributeAttribute || source == popupListener.menuAddAttributeSet || source == popupListener.menuAddAttributeElement){
 
 		Dictionary.setText(this, "GEMS.AddAttribute");
